
#include <machine.h>


#ifdef NORMAL
#include <3664S.h>
#else
#include <3067F.h>
#endif

#define UINT_H


#pragma section W

#define  READWORDS  (8)  /****PICflashǂݏo[hB
						H8RAMTCYƑkĂB
						Ȃ݂8[hConfigWord͓ǂ߂܂*/


/****************** PIC Programer *********/

#include "Connect.h"

uint  readBuf[READWORDS],*up;
uchar CONFIG_OP,READ_OP; /***XCb`*/

PIC()   /***Gg͂***/
{
	uint	r,i;
	uchar *ucp;


	CONFIG_OP = 0; /*ConfigWordƂ0x2000-0x2007Ƃ1 / 0x0000̂Ƃ0 */
	READ_OP   = 0; /**ǂł݂Ƃ1 / ނƂ0*/

	PICReset();	waitus(100); 
	PICBoot(1); 	/*1ForPGM/0ForRUN*/
	waitus(100);

	if(CONFIG_OP) {   
		PICLoadConfig();
		waitus(100);
		if(!READ_OP) PICWriteConfig(CWORDLOCAL); /***ł̓veNg/LVP͂܂*/
	}

	if(READ_OP) {
		up=readBuf; /**READWORDSǂݏo܂**/
		for(i=0;i<READWORDS;i++)  *up++ = PICReadThere();
	} else {
		if(!CONFIG_OP)	{ /*FlashROMւ̏*/
			ucp=PICIMAGE;           /*** PICIMGPICCOUNTSoCg0珑݂܂*/
			for(i=0;i<(PICCOUNTS>>1);i++) {  /*14bitsP=El2oCgł*/
				r=(ucp[1]<<8)|ucp[0];		/*byteSwapĂ܂*/
				PICWriteThere(r);
				ucp+=2;
			}
		}	/******* ȏŏ݂͏I***/
	}
	

/**烆[U[vO𗧂グ܂**********/
	PICReset();	waitus(100); 
	PicRunMode;   /*[UvOPB7/PB6ǂgł킹Ă*/
	PICBoot(0); 	/*1ForPGM/0ForRUN*/

	waitms(100);

/*********ƂSDATAp^p^vOĂ܂
*************p^p^̎ԊԊuTWł͂܂*/
#ifdef NORMAL
	TW.TCRW.BYTE=0x80;
	while (SDATA) ;
	TW.TCNT=0;   /****3048n̏ꍇITUƂŌvĂ**/
	for(i=0;i<200;i++) {
		while (!SDATA) ;
		while ( SDATA) ;
	}
	printf("Timer %u\n",TW.TCNT);
#endif
	trapa(3);
	return(0);
}

PICLoadConfig()
{
	PICSendNBits(0x00,6); /**LoadConfig*/
	PICSendNBits(0x0000,16); 
	return(0);
}

PICReset()
{
	PicWriteMode;
	MCLR = PGM=SDATA=SCLK=0;
	return(0);
}

PICBoot(int sw)
{
	if(sw) PicWriteMode;
	else	PicReadMode;
	PGM=sw;
	MCLR=1; 
	return(0);
}

int
PICWriteConfig(uint cword)
{
	int i;
	PICSendNBits(0x00,6); /**LoadConfig*/
	PICSendNBits(0x0000,16); 
	for(i=0;i<7;i++) {
		PICSendNBits(0x06,6); /*Inc.Addr */
		waitus(10);
	}
	if(!cword) {  /*0̂Ƃdisable CodeProtect̂łݏoĂ܂ */
		PICSendNBits(0x01,6); /***Setup1*/
		PICSendNBits(0x07,6); /***Setup2*/
		PICSendNBits(0x08,6); /***Erase/Prog*/
		waitms(30);
		PICSendNBits(0x01,6); /***Setup1*/
		PICSendNBits(0x07,6); /***Setup2*/
		return(0);
	}

	PICSendNBits(0x02,6); /***WriteCMD*/
	cword |= CWALWAYS; /*Force these bits to 1 CWALWAYSfixĂ܂*/
	PICSendNBits(cword<<1,16); 
	PICSendNBits(0x08,6); /***Erase/Prog*/
	waitms(30);
	return(0);
}


int
PICSendNBits(uint dada,int bits)
{
	int	i;
	uint pat;

	PicWriteMode;
	pat=0x01;
	for(i=0;i<bits;i++)  {
		SCLK=1;
		waitus(2);
		SDATA = (dada & pat) ? 1:0;
		waitus(2);
		pat<<=1;
		SCLK=0;
		waitus(2);
	}
	return(0);
}

uint 
PICRead16Bits(void)
{
	int	i;
	uint pat,dat;

	PicReadMode;
	pat=0x01; dat=0;
	waitus(2);
	for(i=0;i<16;i++)  {
		SCLK=1;
		waitus(2);
		if(SDATA ) 	dat |= pat;
		SCLK=0;
		pat <<=1;
		waitus(2);
	}
	return((dat>>1)&0x3fff);
}


int
PICWriteThere(uint dada)
{
	PICSendNBits(0x02,6); 	/***WriteCMD*/
	PICSendNBits(dada<<1,16); 
	PICSendNBits(0x08,6); /***Erase/Prog*/
	waitms(30);
	PICSendNBits(0x06,6); /*Inc.Addr */
	waitus(100);
	return(0);
}

uint
PICReadThere()
{
	uint r;
	PICSendNBits(0x04,6); /*ReadFromPPROGRAM*/
	r=PICRead16Bits();
	PICSendNBits(0x06,6); /*Inc.Addr */
	return(r);
}

/*****************************************/
#ifndef waitms
waitms(int ms)
{
	while (ms--) waitus(1000);
	
}
#endif

#ifndef waitus 
waitus(int usec)
{
#ifdef TMW_WAIT
	 /***TW must be initted., max 31msec */
	TW.GRB=(TW.TCNT+(usec<<1))&0xffff;
	TW.TSRW.BIT.IMFB=0;
	while(TW.TSRW.BIT.IMFB==0) ;
#else
    int v;
    v=usec;    while(v) v--;
    v=usec;    while(v) v--;
#endif
}
#endif


