MYTARGET = ledFlash


PICASM  = C:\myDir\PIC\newVersion\MPLAB\MPASMWIN.EXE  
CC = CH38.EXE  		
LN = LNK.EXE

INCDIR  = C:\myDir\H8\c\include
LIBDIR  = C:\myDir\H8\c\lib


# 3048/3052/3067pB
H8ASM = asm38.exe 
H8OPT = -CPU=300ha -INCLUDE=$(INCDIR) -def=ADVANCED=1
LNKOPT = -lib=$(LIBDIR)\C38HA.LIB -print=$* -st=PW,P,Z(0ffef20)


# 3664FpB\[X͖Ή
#H8ASM = asm38.exe
#H8OPT = -CPU=300hn -INCLUDE=$(INCDIR) -def=NORMAL=1
#LNKOPT = -lib=$(LIBDIR)\C38HN.LIB -print=$* -st=P,PW,Z(0f780)






PICWrter.abs:	$*.obj $(MYTARGET).obj
	$(LN) $1 $2 $(LNKOPT)

$(MYTARGET).obj:  $(MYTARGET).mar
	$(H8ASM) $1 $(H8OPT)



$(MYTARGET).mar: $(MYTARGET).hex
	cscript hexExtr.js  $1 $@


$(MYTARGET).hex: $(MYTARGET).asm
	$(PICASM) $1






PICWrter.obj: $*.c Connect.h
	$(CC) $(H8OPT) $1


clean:
	@del *.obj
	@del *.mot
	@del *.abs
	@del *.lst
	@del *.map
	@del *.hex
	@del *.map
	@del *.cod
	@del *.err
	@del $(MYTARGET).mar


.end:
	@echo DONE


